<?php
/*
	Plugin Name: Textplace
	Version: .91
	Plugin URI: http://www.samgerstenzang.com/textplace.html
	Description: Textplace is a plugin to include commonly used text across multiple posts, pages and templates.
	Author: Sam Gerstenzang
	Author URI: http://www.samgerstenzang.com/
*/

/*  
	Copyright 2008  Sam Gerstenzang  (email : sgerstenzang@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
?>


<?php

register_activation_hook( __FILE__, 'textplace_install' );

function textplace_install () {
	global $wpdb;
	$table_name = $wpdb->prefix . "textplace";
	
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
  
		$sql = "CREATE TABLE " . $table_name . " (
				id mediumint(9) NOT NULL AUTO_INCREMENT,
				name tinytext NOT NULL,
				text text,
				UNIQUE KEY id (id)
				);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
   }
}


add_action('admin_menu', 'textplace_add_menu');
function textplace_add_menu(){
	add_management_page('Textplace', 'Textplace', '3', 'textplace','show_textplace');
	wp_enqueue_script('jquery');
	// if (user_can_richedit())wp_enqueue_script('editor');
	// wp_enqueue_script('thickbox');
	// wp_enqueue_script('media-upload');
}

function show_textplace(){
 	global $wpdb;
	$table_name = $wpdb->prefix . "textplace";
	
	if(isset($_POST['textplace_id']) && !isset($_POST['textplace_action'])){
		$id = $_POST['textplace_id'];
		$post = $_POST["textplace_text$id"];
		$sql = "UPDATE $table_name set text = %s where id = %d";
		$results = $wpdb->query($wpdb->prepare($sql,$post,$id));
	}
	
	if (isset($_POST['textplace_action']) && $_POST['textplace_action'] == "delete"){
		$id = $_POST['textplace_id'];
		$sql = "DELETE FROM $table_name where id = %d";
		$results = $wpdb->query($wpdb->prepare($sql,$id));
	}

	if(isset($_POST['textplace_name'])){
		$name = $_POST['textplace_name'];
		$sql = "INSERT INTO $table_name (name) VALUES (%s)";
		$results = $wpdb->query($wpdb->prepare($sql,$name));
	}
	?>	
	<style type='text/css' media='screen'>
		#textplace{width:900px;padding-left:15px;}
		#textplace #editorcontainer{background-color:#82D2EA;margin-bottom:20px;width:900px;}
		#textplace form{display:inline;}
		#textplace #tags{float:right;width:300px;height:200px;}
	</style>
	<div id="textplace">
	<h1>Textplace</h1><hr />
	<?php
  	$sql = "SELECT * FROM $table_name";
	$results = $wpdb->get_results($sql);
	foreach($results as $result){ ?>
		<style type='text/css' media='screen'>
			#textplace #tag<?php print $result->id;?>{display:none;}
		</style>
		<div id="editorcontainer">		
			<h3><?php print $result->name; ?>
				
			<form method='post' action='<?php print $_SERVER["REQUEST_URI"]; ?>'><input type='hidden' name='textplace_id' value='<?php print $result->id; ?>'><input type='hidden' name='textplace_action' value='delete' /><input type='submit' value='Delete'></form>
			</h3>
				<div id="tags">
				<a class="slide<?php print $result->id;?>">Insert into Page/Template</a>
				<div id="tag<?php print $result->id;?>">
				For pages/posts: [textplace id="<?php print $result->id; ?>"] <br />
				For templates: &lt;?php&nbsp; grab_textplace("<?php print $result->id; ?>"); ?&gt;
				</div>
				</div>
			<form method='post' action='<?php print $_SERVER["REQUEST_URI"]; ?>'><input type='hidden' name='textplace_id' value='<?php print $result->id; ?>' />
					<script>
						$j=jQuery.noConflict();
						$j(document).ready(function(){

							$j(".slide<?php print $result->id;?>").click(function(){
							  $j("#tag<?php print $result->id;?>").slideToggle("slow");
							  $j(this).toggleClass("active");
							});

						});
					</script>
			
			<textarea cols='60' rows='4' name='textplace_text<?php print $result->id; ?>'><?php print stripslashes(htmlentities($result->text)); ?></textarea>
				
			
			 <!-- the_editor($result->text,"textplace_text$result->id","textplace_text$result->id"); -->
			<br />
			<input type='submit' value='Update'>
			
			
			</form>
		
		</div>
	<?php
	}
	?>
	<hr />
	
	New textplace:<form method='post' action='<?php print $_SERVER["REQUEST_URI"]; ?>'><input type='text' name='textplace_name'><input type='submit' value='Add'></form>
	</div>
	<?php
}

function fetch_textplace($id){
	global $wpdb;
	$table_name = $wpdb->prefix . "textplace";

	$sql = "SELECT * FROM $table_name where id = %d";
	$result = $wpdb->get_row($wpdb->prepare($sql,$id));
	return stripslashes($result->text);
}

function grab_textplace($id){
	print fetch_textplace($id);
}

function textplace_shortcode($atts) {
	extract(shortcode_atts(array('id' => '-1',), $atts));

	return fetch_textplace($id);
}

add_shortcode('textplace', 'textplace_shortcode');
?>